#include <amxmodx>
#include <reapi>

// Constants.
stock const ENT_CLASSNAME[] = "func_breakable"
stock const TASK_AIM = 100
stock const Float:INTERVAL = 0.5

// HUD Positions.
const Float:HUD_X = 0.1
const Float:HUD_Y = -0.3

// Colors indexes.
enum _:Colors
{
	Red = 0,
	Green,
	Blue
}

// Cvars
new g_iMode,
	g_iColors[Colors],
	bool:g_bRandColors,
	Float:g_flDistance

public plugin_init()
{
	// Load Plug-In.
	register_plugin("[ZE] Addon: Breakable Hint", "1.2", "Raheem")

	// Cvars
	new pCvarMessageMode = register_cvar("ze_breakhint_mode", "2")

	bind_pcvar_num(pCvarMessageMode, g_iMode)

	bind_pcvar_num(register_cvar("ze_breakhint_hud_rand_colors", "1"), g_bRandColors)
	bind_pcvar_num(register_cvar("ze_breakhint_hud_red", "0"), g_iColors[Red])
	bind_pcvar_num(register_cvar("ze_breakhint_hud_green", "200"), g_iColors[Green])
	bind_pcvar_num(register_cvar("ze_breakhint_hud_blue", "0"), g_iColors[Blue])

	bind_pcvar_float(register_cvar("ze_breakhint_distance", "500.0"), g_flDistance)

	hook_cvar_change(pCvarMessageMode, "cvar_MessageMode")

	// Tasks
	set_task(INTERVAL, "check_Entity", TASK_AIM, "", 0, "b")
}

public cvar_MessageMode(pCvar)
{
	if (!g_iMode)
	{
		// Remove Task.
		remove_task(TASK_AIM)
	}
	else
	{
		if (!task_exists(TASK_AIM))
			set_task(INTERVAL, "check_Entity", TASK_AIM, "", 0, "b")
	}
}

public check_Entity(taskid)
{
	static iClients[MAX_PLAYERS], iAliveNum, id, i
	get_players(iClients, iAliveNum, "ah")

	for (i = 0; i < iAliveNum; i++)
	{
		id = iClients[i]

		static iEnt
		if (g_flDistance > 0.0 && !(get_user_aiming(id, iEnt) <= g_flDistance))
			continue

		// func_breakable?
		if (FClassnameIs(iEnt, ENT_CLASSNAME))
		{
			// 1: Trigger Only?
			if (get_entvar(iEnt, var_spawnflags) & SF_BREAK_TRIGGER_ONLY)
				continue

			switch (g_iMode)
			{
				case 1: // Text Message.
				{
					client_print(id, print_center, "%L", LANG_PLAYER, "MSG_BREAK_HINT")
				}
				case 2: // HUD.
				{
					if (g_bRandColors)
						set_hudmessage(random(256), random(256), random(256), HUD_X, HUD_Y, 0, 0.6, 0.6)
					else
						set_hudmessage(g_iColors[Red], g_iColors[Green], g_iColors[Blue], HUD_X, HUD_Y, 0, 0.6, 0.6)
					show_hudmessage(id, "%L", LANG_PLAYER, "MSG_BREAK_HINT")
				}
				case 3: // DHUD.
				{
					if (g_bRandColors)
						set_dhudmessage(random(256), random(256), random(256), HUD_X, HUD_Y, 0, 0.6, 0.6)
					else
						set_dhudmessage(g_iColors[Red], g_iColors[Green], g_iColors[Blue], HUD_X, HUD_Y, 0, 0.6, 0.6)
					show_dhudmessage(id, "%L", LANG_PLAYER, "MSG_BREAK_HINT")
				}
			}
		}
	}
}